Subject: Re: e1000 driver and samba

From: Bruce Cole <[email-masked]>
Date: Fri, 21 Sep 2007 15:01:47 -0700

Francois Romieu wrote:
> Bruce Cole <[email-masked]> :
>   
>>> If you look for it on the Realtek cards, there had been sporadic
>>> Nissues up to late 2005. The solution posted universally was 'change
>>> card'.
>>>       
>> Yes, that *was* the common recommendation.
>>     
>
> There was no such thing as a universal solution to sporadic issues.
>   
I made no such claim.  I do claim the realtek samba et all issues are 
not sporadic however.  In fact the
common problem is readily reproducible as has been shown.
> [...]
>   
>> I suspect the root problem is the driver isn't properly locking
>> the TX queue.
>>     
>
> Can you be more specific ?
>   
Yes per the reference I gave:
http://www.spinics.net/lists/netdev/msg40384.html
"Now since this change heals the TX queue stall, it would seem that the real

underlying problem involves a race condition with enqueueing to the TX queue

while the controller is processing the queue. The ultimate fix for that 
I bet is either to address locking at TX enqueue time, or there is a 
controller bug. Any clarification from realtek on the necessary 
processing for the NPQ bit, or

a known controller problem?

PS: I've also received private email that this problem pertains to video
streaming (to a Kiss DVD player) not just samba or X11 traffic.  Basically
most all high-level TCP based protocols are affected it seems.  This serious

performance problem should be considered to impact a lot more than just 
samba

users."

I could probably help fix the underlying problem but I didn't
receive any response to my post quoted above.